C
C     GSX-80 DRIVER for HP 2648A Terminal
C     Copyright (C) 2014 by Udo Munk
C     Copyright (C) 2020 by Martin Hepperle
C
C234567890123456789012345678901234567890123456789012345678901234567890123456789
C----vv----------------------------------------------------------------v-------
      SUBROUTINE DD2648(CONTRL,INTIN,PTSIN,INTOUT,PTSOUT)
      INTEGER CONTRL(1),INTIN(1),PTSIN(1),INTOUT(1),PTSOUT(1)
C
C     VARIABLES
C
      INTEGER I,J,K
      INTEGER OPCODE,INMODE
      LOGICAL PFLAG,OFLAG
      INTEGER LNTP,MKTP
      INTEGER MSIZE
      INTEGER XY(2)
      INTEGER XLO,YLO,XHI,YHI
      INTEGER*1 LINE(20)
      INTEGER*2 LINES(9)
C
C     FUNCTIONS
C
      EXTERNAL IGET3, CLAMP
      INTEGER  IGET3, CLAMP
C
C     DATA
C
C     FONT SIZES 5x7, 8 multiples
C     CELL SIZES 7x10, 8 multiples
C     PRINT FLAG FOR DRIVER COPYRIGHT AND VERSION TEXT
      DATA PFLAG /.FALSE./
C     WORKSTATION OPEN FLAG
      DATA OFLAG /.FALSE./
C     MARKER SIZE 6 and up
      DATA MSIZE/6/
C     TABLE OF LINE TYPES
      DATA LINES /1,7,4,5,6,8,9,10,11/
C
C     INITIALIZATION
C
      CONTRL(3) = 0
      CONTRL(5) = 0
      OPCODE = CONTRL(1)

C     DONT DRAW ON CLOSED WOKSTATION
      IF (OFLAG .NE. .TRUE. .AND. OPCODE .NE. 1) RETURN

C
C     DISPATCH ON OPCODE
C
      GOTO(1100,1200,1300,1400,1500,1600,1700,1800,1900,2000,
     1     2100,2200,2300,2400,2500,2600,2700,2800,2900,3000,
     2     3100,3200,3300,3400,3500,3600,3700,3800,3900,4000,
     3     4100,4200,4300),OPCODE
      RETURN

C
C     OPCODE OPEN WORKSTATION
C
1100  IF (PFLAG .NE. .FALSE.) GOTO 1110
      CALL HPPRTV
      PFLAG = .TRUE.
1110  CONTRL(3) = 6
      CONTRL(5) = 45
      LNTP = CLAMP(INTIN(2),1,9)
      MKTP = CLAMP(INTIN(4),1,6)
      INTOUT(1) = 720-1
      INTOUT(2) = 360-1
      INTOUT(3) = 1
      INTOUT(4) = 352
      INTOUT(5) = 352
      INTOUT(6) = 4
      INTOUT(7) = 9
      INTOUT(8) = 1
      INTOUT(9) = 5
      INTOUT(10) = 4
      INTOUT(11) = 1
      INTOUT(12) = 0
      INTOUT(13) = 0
      INTOUT(14) = 2
      INTOUT(15) = 0
      INTOUT(16) = -1
      INTOUT(17) = -1
      INTOUT(18) = -1
      INTOUT(19) = -1
      INTOUT(20) = -1
      INTOUT(21) = -1
      INTOUT(22) = -1
      INTOUT(23) = -1
      INTOUT(24) = -1
      INTOUT(25) = -1
      INTOUT(26) = -1
      INTOUT(27) = -1
      INTOUT(28) = -1
      INTOUT(29) = -1
      INTOUT(30) = -1
      INTOUT(31) = -1
      INTOUT(32) = -1
      INTOUT(33) = -1
      INTOUT(34) = -1
      INTOUT(35) = -1
      INTOUT(36) = 0
      INTOUT(37) = 1
      INTOUT(38) = 0
      INTOUT(39) = 0
      INTOUT(40) = 2
      INTOUT(41) = 1
      INTOUT(42) = 0
      INTOUT(43) = 0
      INTOUT(44) = 1
      INTOUT(45) = 2
      PTSOUT(1) = 0
      PTSOUT(2) = 1*7
      PTSOUT(3) = 0
      PTSOUT(4) = 4*7
      PTSOUT(5) = 1
      PTSOUT(6) = 0
      PTSOUT(7) = 1
      PTSOUT(8) = 0
      PTSOUT(9) = 0
      PTSOUT(10) = 8
      PTSOUT(11) = 0
      PTSOUT(12) = 32
      OFLAG = .TRUE.
C     CLEAR and RETURN
      GOTO 1300

C
C     OPCODE CLOSE WORKSTATION
C
1200  CONTINUE
      OFLAG = .FALSE.
      RETURN

C
C     OPCODE CLEAR WORKSTATION
C
C     clear grapics
1300  CALL ESC('*daZ',4)
      RETURN

C
C     OPCODE UPDATE WORKSTATION
C
1400  RETURN

C
C     OPCODE ESCAPE
C
1500  OPCODE = CONTRL(6)
C     DISPATCH ON FUNCTION
      GOTO(1501,1502,1503,1504,1505,1506,1507,1508,1509,1510,
     1     1511,1512,1513,1514),OPCODE
      RETURN
C     INQUIRE ADDRESSABLE CHARACTER CELLS
1501  INTOUT(1) = 24
      INTOUT(2) = 80
      RETURN

C     ENTER GRAPHICS MODE
1502  CALL HPINIT
      RETURN

C     EXIT GRAPHICS MODE
1503  CALL HPEXIT
      RETURN

C     CURSOR UP     Esc A
1504  CALL ESC('A',1)
      RETURN
C     CURSOR DOWN   Esc B
1505  CALL ESC('B',1)
      RETURN
C     CURSOR RIGHT  Esc C
1506  CALL ESC('C',1)
      RETURN
C     CURSOR LEFT   Esc D
1507  CALL ESC('D',1)
      RETURN
C     HOME CURSOR
1508  CALL ESC('H',1)
      RETURN
C     ERASE TO END OF SCREEN
1509  CALL ESC('J',1)
      RETURN
C     ERASE TO END OF LINE
1510  CALL ESC('K',1)
      RETURN
C     DIRECT CURSOR ADDRESS
C     Esc & a 12 r 04 C == row and column
1511  CALL ESC('&a',2)
      I = CLAMP(INTIN(1),1,24)
      CALL OUTNUM(I)
      CALL HPOUT('r')
      I = CLAMP(INTIN(2),1,80)
      CALL OUTNUM(I)
      CALL HPOUT('C')
      RETURN
C     OUTPUT CURSOR ADDRESSABLE TEXT
1512  CONTINUE
      CALL HPSTR(CONTRL(4),INTIN)
      RETURN
C     REVERSE VIDEO ON
C     Esc & d B == inverse
1513  CALL ESC('&dB',3)
      RETURN
C     REVERSE VIDEO OFF
1514  CALL ESC('&d@',3)
      RETURN

C
C     OPCODE POLYLINE
C
1600  CONTINUE
      CALL ESC('*pa',3)
      J = CONTRL(2)
      K = 1
      DO 1601 I=1,J
         CALL XYPAIR(PTSIN(K),PTSIN(K+1))
      K = K + 2
1601  CONTINUE
      CALL HPOUT('Z')
      RETURN

C
C     7: OPCODE POLYMARKER
C
1700  CONTINUE
      J = 1
      K = CONTRL(2)
      DO 1701 I=1,K
      XY(1) = PTSIN(J)
      XY(2) = PTSIN(J+1)
      CALL MPLOT(XY,MKTP,MSIZE)
      J = J + 2
1701  CONTINUE
      RETURN

C
C     8: OPCODE TEXT
C
1800  CALL ESC('*pa',3)
      CALL XYPAIR(PTSIN(1),PTSIN(2))
      CALL HPOUT('Z')
      CALL ESC('*l',2)
      CALL HPSTR(CONTRL(4),INTIN)
      CALL HPOUT(13)
      RETURN

C
C     9: OPCODE FILLED AREA
C
1900  J = 1
      K = CONTRL(2)
      CALL ESC('*pa',3)
      DO 1901 I=1,K
      CALL XYPAIR(PTSIN(J),PTSIN(J+1))
      J = J + 2
1901  CONTINUE
      CALL HPOUT('Z')
      RETURN

C
C     10: OPCODE CELL ARRAY
C
2000  CONTINUE
C     CALL HPOUT(29)
C     CALL HPOUT(27)
C     CALL HPOUT(96)
      XLO = PTSIN(1)
      XHI = PTSIN(2)
      XHI = PTSIN(3)
      YHI = PTSIN(4)
C     CALL XYPAIR(XLO,YLO)
C     CALL XYPAIR(XHI,YLO)
C     CALL XYPAIR(XHI,YHI)
C      CALL XYPAIR(XLO,YLO)
C      CALL HPOUT(27)
C      CALL HPOUT(LNTP+95)
C      CALL HPOUT(31)
      RETURN

C
C     OPCODE GENERALZED DRAWING PRIMITIVE
C
2100  RETURN

C
C     OPCODE SET CHARACTER HEIGHT
C
2200  I = PTSIN(2)
      J = MAX0(1,(I+4)/7)

      CALL ESC('*m',2)
      CALL OUTNUM(J)
      CALL HPOUT('M')

      CONTRL(3) = 2
      PTSOUT(1) = J*5
      PTSOUT(2) = J*7
      PTSOUT(3) = J*7
      PTSOUT(4) = J*10
      RETURN

C
C     OPCODE SET CHARACTER UP VECTOR
C
2300  J = CLAMP(INTIN(1),0,3600)
      J = 1 + J/900
      CALL ESC('*m',2)
      CALL OUTNUM(J)
      CALL HPOUT('N')
      INTOUT(1) = (J-1)*900
      CONTRL(5) = 1
      RETURN

C
C     OPCODE SET COLOR REPRESENTATION
C
2400  CONTINUE
      RETURN

C
C     OPCODE SET POLYLINE LINETYPE
C
2500  LNTP = CLAMP(INTIN(1),1,9)
C     USE TABLE
      LNTP = LINES(LNTP)
      INTOUT(1) = LNTP
      CALL ESC('*m',2)
      CALL OUTNUM(LNTP)
      CALL HPOUT('B')
      RETURN

C
C     OPCODE SET POLYLINE WIDTH
C
2600  CONTRL(3) = 1
      PTSOUT(1) = 1
      PTSOUT(2) = 0
      RETURN

C
C     OPCODE SET POLYLINE COLOR INDEX
C
2700  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET POLYMARKER TYPE
C
2800  MKTP = CLAMP(INTIN(1),1,6)
      INTOUT(1) = MKTP
      RETURN

C
C     19: OPCODE SET POLYMARKER SCALE
C
2900  MSIZE = MAX0(6,PTSIN(2))
      CONTRL(3) = 1
      PTSOUT(1) = 0
      PTSOUT(2) = MSIZE
      RETURN

C
C     OPCODE SET POLYMARKER COLOR INDEX
C
3000  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET TEXT FONT
C
3100  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET TEXT COLOR INDEX
C
3200  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET FILL INTERIOR STYLE
C
3300  INTOUT(1) = 0
      RETURN

C
C     OPCODE SET FILL STYLE INDEX
C
3400  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET FILL COLOR INDEX
C
3500  INTOUT(1) = 1
      RETURN

C
C     OPCODE INQUIRE COLOR REPRESENTATION
C
3600  INTOUT(1) = INTIN(1)
      INTOUT(2) = 0
      INTOUT(3) = 0
      INTOUT(4) = 0
      RETURN

C
C     OPCODE INQUIRE CELL ARRAY
C
3700  CONTRL(8) = 0
      CONTRL(9) = 0
      CONTRL(10) = 1
      RETURN

C
C     OPCODE INPUT LOCATOR
C
3800  CALL ESC('*s4^',4)
C     send DC1
      CALL HPOUT(17)
      DO 3820 I=1,18
         CALL HPIN(LINE(I))
3820  CONTINUE
C     "+00000,+00000,000"+CR
C      12345678901234567  8
      CONTRL(5) = 1
      CONTRL(3) = 1
      PTSOUT(1) = IGET3(LINE,4)
      PTSOUT(2) = 360 - IGET3(LINE,11)
      I         = IGET3(LINE,15)
      IF (I.GT.127) GOTO 3830
C     KEYBOARD TERMINATION
      INTOUT(1) = I
      RETURN
3830  CONTINUE
C     LEFT MOUSE BUTTON TERMINATION  232->32
C     RIGHT MOUSE BUTTON TERMINATION 233->33
      INTOUT(1) = I-200
      RETURN

C
C     OPCODE INPUT VALUATOR
C
3900  CONTRL(5) = 0
      RETURN

C
C     OPCODE INPUT CHOICE
C
4000  CONTRL(5) = 0
      RETURN

C
C     OPCODE INPUT STRING
C
4100  RETURN

C
C     OPCODE SET WRITING MODE
C
4200  INTOUT(1) = 2
      RETURN

C
C     OPCODE SET INPUT MODE
C
4300  INMODE = INTIN(2)
      INTOUT(1) = INMODE
      RETURN

      END

      SUBROUTINE HPINIT
C     graphics ON
      CALL ESC('*dcZ',4)
      RETURN
      END

      SUBROUTINE HPEXIT
      RETURN
      END

C
C     CONVERT XY COORDINATES TO "X,Y " AND OUTPUT
C
      SUBROUTINE XYPAIR(X,Y)
      INTEGER X,Y
      INTEGER N,ACK
      DATA N /0/

      N = N+1
      IF ( N .LT. 20 ) GOTO 10

C     send ENQ (5)
      CALL HPOUT(5)
C     read ACK (6)
      CALL HPIN(ACK)
      N = 0

10    CONTINUE
      CALL OUTNUM(X)
      CALL HPOUT(',')
      CALL OUTNUM(Y)
      CALL HPOUT(' ')

      RETURN

      END

C
C     Draw a marker at the location given in [INITIN(1),INITIN(2)]
C
      SUBROUTINE MPLOT(INTIN,TYPE,PMSC)
      INTEGER INTIN(2),TYPE,PMSC

      INTEGER X1,X2,Y1,Y2
      INTEGER X3,X4,Y3,Y4
      INTEGER RXY1,RXY2

C     bounding box
      X1 = INTIN(1) - PMSC/2
      X2 = X1 + PMSC
      Y1 = INTIN(2) - PMSC/2
      Y2 = Y1 + PMSC

C     test bounding box
C      IF (MIN0(X1,Y1).LT.0 .OR. MAX0(X2,Y2).GT.32767) RETURN

      IF (X1.LT.0     .OR. Y1.LT.0 .OR.
     1    X2.GT.32767 .OR. Y2.GT.32767) RETURN

C     for 'x' and '*' approx. PMSC*COS(PI/4)
      RXY1 = PMSC/3 + PMSC/50
      X3 = INTIN(1) - RXY1
      X4 = INTIN(1) + RXY1
      Y3 = INTIN(2) - RXY1
      Y4 = INTIN(2) + RXY1

      CALL ESC('*pa',3)

      IF (TYPE.EQ.1 .OR. TYPE.EQ.4 .OR. TYPE.EQ.6) GOTO 5040
      IF (TYPE.EQ.3 .OR. TYPE.EQ.5) GOTO 5020
C     TYPE .EQ. 2 or invalid
      GOTO 5035

C     3,5: 'x'
5020  CONTINUE
      CALL XYPAIR(X3,Y3)
      CALL XYPAIR(X4,Y4)
      CALL HPOUT('a')
      CALL XYPAIR(X3,Y4)
      CALL XYPAIR(X4,Y3)
5030  IF (TYPE.EQ.3) GOTO 5035
      GOTO 5060

C     2,3: '+'
5035  CONTINUE
      X3 = X1 + PMSC/2
      Y3 = Y1 + PMSC/2
      CALL XYPAIR(X3,Y1)
      CALL XYPAIR(X3,Y2)
      RXY1 = X1 + PMSC/2
      CALL HPOUT('a')
      CALL XYPAIR(X1,Y3)
      CALL XYPAIR(X2,Y3)
      GOTO 5060

C     1,4,6: dot = small x
5040  CONTINUE
      X3 = X1 + PMSC/2 - 30
      Y3 = Y1 + PMSC/2 - 30
      X4 = X3 + 60
      Y4 = Y3 + 60
      CALL XYPAIR(X3,Y3)
      CALL XYPAIR(X4,Y4)
      CALL HPOUT('a')
      CALL XYPAIR(X3,Y4)
      CALL XYPAIR(X4,Y3)
      IF (TYPE.EQ.1) GOTO 5060
      IF (TYPE.EQ.6) GOTO 5050
C     4: fall through

C     4: square with dot
5045  CONTINUE
      CALL HPOUT('a')
      CALL XYPAIR(X1,Y1)
      CALL XYPAIR(X2,Y1)
      CALL XYPAIR(X2,Y2)
      CALL XYPAIR(X1,Y2)
      CALL XYPAIR(X1,Y1)
      GOTO 5060

C     6: diamond with dot
5050  CONTINUE
      X3 = X1 + PMSC/2
      Y3 = Y1 + PMSC/2
      CALL HPOUT('a')
      CALL XYPAIR(X1,Y3)
      CALL XYPAIR(X3,Y2)
      CALL XYPAIR(X2,Y3)
      CALL XYPAIR(X3,Y1)
      CALL XYPAIR(X1,Y3)

5060  CALL HPOUT('Z')
      RETURN

      END
C
C     Parse 3 digits from character array, starting at I
C
      INTEGER FUNCTION IGET3(LINE,I)
      INTEGER*1 LINE(20)
      INTEGER I
      IGET3 = (LINE(I) -48)*100 +
     1        (LINE(I+1) -48)*10  +
     2         LINE(I+2) -48
      RETURN
      END
C
C     OUTPUT Esc, C(1...N)
C
      SUBROUTINE ESC(C,N)
      INTEGER*1 C(80)
      INTEGER N
      CALL HPOUT(27)
      DO 100 I=1,N
      CALL HPOUT(C(I))
100   CONTINUE
      RETURN
      END
C
C     OUTPUT 1 TO 3 DIGIT DECIMAL NUMBER IN ASCII
C
      SUBROUTINE OUTNUM(I)
      INTEGER I,J,K

      K = I
      IF (K.LT.10) GOTO 10
      IF (K.LT.100) GOTO 100
      IF (K.LT.1000) GOTO 1000
      RETURN

1000  J = K/100
      CALL HPOUT(J+48)
      K = K - J*100 

100   J = K/10
      CALL HPOUT(J+48)
      K = K - J*10

10    J = K
      CALL HPOUT(J+48)
      RETURN

      END

C
C     Limit I to the range LO...HI
C
      INTEGER FUNCTION CLAMP ( I, LO, HI )
      INTEGER I,LO,HI

      IF ( I .LT. LO ) GOTO 100
      IF ( I .GT. HI ) GOTO 200

      CLAMP = I
      RETURN

100   CLAMP = LO
      RETURN

200   CLAMP = HI
      RETURN

      END
